-- CamDispCntrl_SRAM_tb.vhd

library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

library modelsim_lib;
use modelsim_lib.util.all;

entity testbench is
end testbench;

architecture testbench_arc of testbench is
component CamDispCntrl_SRAM
	port (
		clk	: in std_logic;			-- U킩48MHzNbN
		cam_vsync : in std_logic;	-- CMOSJVSYNC
		cam_href : in std_logic;	-- CMOSJHREF
		cam_pclk : in std_logic;		-- CMOSJpclk
		cam_ydata : in std_logic_vector(7 downto 0); -- CMOSJYf[^
		-- cam_sio_c : out std_logic;	-- CMOSJI2CNbN
		-- cam_sio_d : inout std_logic; -- CMOSJI2Cf[^
		cam_clk	: out std_logic; 	-- CMOSJ̃NbN
		cam_reset	: out std_logic; 	-- CMOSJ̃ZbgiLŃZbg̗\j
		dac_red	: out std_logic_vector(7 downto 0);	-- DACւREDo
		dac_green : out std_logic_vector(7 downto 0); -- DACւGREENo
		dac_blue : out std_logic_vector(7 downto 0); -- DACւBLUEo
		n_dac_blank : out std_logic; -- DACւ̃ANeBu[BLANK
		dac_clk : out std_logic; -- DACNbNi24MHzj
		vga_vsync : out std_logic; -- VGAVSYNC
		vga_hsync : out std_logic; -- VGAHSYNC
		mem_data : inout std_logic_vector(15 downto 0);	-- SRAMmemory data
		n_mem_we : out std_logic; -- SRAMmemory write enable
		n_mem_rd : out std_logic; -- SRAMmemory read enable
		n_mem_cs0 : out std_logic; -- SRAMchip select 0
		n_mem_cs1 : out std_logic; -- SRAMchip select 1
		n_mem_cs2 : out std_logic; -- SRAMchip select 2
		n_mem_cs3 : out std_logic; -- SRAMchip select 3
		n_mem_lowerB : out std_logic; -- SRAMmemory lower byte enable
		n_mem_upperB : out std_logic; -- SRAMmemory upper byte enable
		mem_addr : out std_logic_vector(17 downto 0) -- SRAMmemory address
	);
end component;

component OV7640_Model
	port(
		clk : in std_logic; -- NbN
		reset : in std_logic; -- Zbg
		vsync : out std_logic;
		href : out std_logic;
		pclk : out std_logic;
		ydata : out std_logic_vector(7 downto 0)
		-- sio_c : in std_logic;
		-- sio_d : inout std_logic
	);
end component;

component IS61LV25616
	port(
		mem_data : inout std_logic_vector(15 downto 0);	-- SRAMmemory data
		n_mem_we : in std_logic; -- SRAMmemory write enable
		n_mem_rd : in std_logic; -- SRAMmemory read enable
		n_mem_cs : in std_logic; -- SRAMchip select 0
		n_mem_lowerB : in std_logic; -- SRAMmemory lower byte enable
		n_mem_upperB : in std_logic; -- SRAMmemory upper byte enable
		mem_addr : in std_logic_vector(17 downto 0) -- SRAMmemory address
	);
end component;

signal clk	: std_logic := '1';			-- U킩48MHzNbN
signal cam_vsync : std_logic;	-- CMOSJVSYNC
signal cam_href : std_logic;	-- CMOSJHREF
signal cam_pclk : std_logic;		-- CMOSJpclk
signal cam_ydata : std_logic_vector(7 downto 0); -- CMOSJYf[^
signal cam_clk	: std_logic; 	-- CMOSJ̃NbN
signal cam_reset	: std_logic; 	-- CMOSJ̃ZbgiHŃZbgj
signal dac_red	: std_logic_vector(7 downto 0);	-- DACւREDo
signal dac_green : std_logic_vector(7 downto 0); -- DACւGREENo
signal dac_blue : std_logic_vector(7 downto 0); -- DACւBLUEo
signal n_dac_blank : std_logic; -- DACւ̃ANeBu[BLANK
signal dac_clk : std_logic; -- DACNbNi24MHzj
signal vga_vsync : std_logic; -- VGAVSYNC
signal vga_hsync : std_logic; -- VGAHSYNC
signal mem_data : std_logic_vector(15 downto 0);	-- SRAMmemory data
signal n_mem_we : std_logic; -- SRAMmemory write enable
signal n_mem_rd : std_logic; -- SRAMmemory read enable
signal n_mem_cs0 : std_logic; -- SRAMchip select 0
signal n_mem_cs1 : std_logic; -- SRAMchip select 1
signal n_mem_cs2 : std_logic; -- SRAMchip select 2
signal n_mem_cs3 : std_logic; -- SRAMchip select 3
signal n_mem_lowerB : std_logic; -- SRAMmemory lower byte enable
signal n_mem_upperB : std_logic; -- SRAMmemory upper byte enable
signal mem_addr : std_logic_vector(17 downto 0); -- SRAMmemory address

begin
	-- clk̐
	clk <= not clk after 10.4 ns; -- 48MHzNbN
	
	CamDispCntrl_SRAM_inst : CamDispCntrl_SRAM port map(
		clk => clk,
		cam_vsync => cam_vsync,
		cam_href => cam_href,
		cam_pclk => cam_pclk,
		cam_ydata => cam_ydata,
		cam_clk => cam_clk,
		cam_reset => cam_reset,
		dac_red => dac_red,
		dac_green => dac_green,
		dac_blue => dac_blue,
		n_dac_blank => n_dac_blank,
		dac_clk => dac_clk,
		vga_vsync => vga_vsync,
		vga_hsync => vga_hsync,
		mem_data => mem_data,
		n_mem_we => n_mem_we,
		n_mem_rd => n_mem_rd,
		n_mem_cs0 => n_mem_cs0,
		n_mem_cs1 => n_mem_cs1,
		n_mem_cs2 => n_mem_cs2,
		n_mem_cs3 => n_mem_cs3,
		n_mem_lowerB => n_mem_lowerB,
		n_mem_upperB => n_mem_upperB,
		mem_addr => mem_addr
	);
	
	OV7640_Model_inst : OV7640_Model port map(
		clk => cam_clk,
		reset => cam_reset,
		vsync => cam_vsync,
		href => cam_href,
		pclk => cam_pclk,
		ydata => cam_ydata
	);

	IS61LV25616_inst : IS61LV25616 port map(
		mem_data => mem_data,
		n_mem_we => n_mem_we,
		n_mem_rd => n_mem_rd,
		n_mem_cs => n_mem_cs0,
		n_mem_lowerB => n_mem_lowerB,
		n_mem_upperB => n_mem_upperB,
		mem_addr => mem_addr
	);
	
end testbench_arc;
	