-- SRAM CONTROLLER
-- VGA Display ControllerCMOSJ̃AhX𐶐ASRAMɓ͂
-- Read, Write݂Ɏs
-- master_sync ɓďʃoCgAʃoCg݂؂ւ
-- mem_data̓͂͏ʃW[Ńb`Ē VGA_Display_Controller ɓ

library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

library work;
use work.disp_timing_pack.all;

entity SRAM_Controller is
	port(
		clk : in std_logic;
		clk48 : in std_logic;
		reset : in std_logic;
		r_w : in std_logic; -- Read or Write
		master_sync : in std_logic;
		cam_href_3d : in std_logic; -- cam_href 3NbNxAeW[2NbNx̐MgĂ̂ŁA1NbNxĂMwẽCl[uƂĎgpBUYVYƃf[^̂ŁATv̂1NbNx邩B
		cam_mem_addr : in std_logic_vector(17 downto 0); -- CMOSJ̏ݗp̃AhX
		cam_ydata_in : in std_logic_vector(7 downto 0); -- CMOSJ̃f[^
		vga_mem_addr : in std_logic_vector(18 downto 1); -- VGARg[[pǂݏopAhX
		
		mem_data_out : out std_logic_vector(15 downto 0); -- SRAM̃f[^óBCMOSJ̃f[^QW߂́B
		mem_data_oe : out std_logic; -- SRAMmemory datao͂Output Enable
		
		n_mem_we : out std_logic; -- SRAMWE
		n_mem_cs0 : out std_logic; -- SRAMchip select 0
		n_mem_cs1 : out std_logic; -- SRAMchip select 1
		n_mem_cs2 : out std_logic; -- SRAMchip select 2
		n_mem_cs3 : out std_logic; -- SRAMchip select 3
		n_mem_lowerB : out std_logic; -- SRAMmemory lower byte enable
		n_mem_upperB : out std_logic; -- SRAMmemory upper byte enable
		mem_addr : out std_logic_vector(17 downto 0) -- SRAMmemory address
	);
end SRAM_Controller;

architecture RTL of SRAM_Controller is
type UPPER_LOWER_STATE is (read_state1, upper_state, read_state2, lower_state);
signal cs_ul, ns_ul : UPPER_LOWER_STATE;
type MEM_WE_STATE is (idle_we, we_active, we_holdoff);
signal cs_we, ns_we : MEM_WE_STATE;
signal n_mem_we_node : std_logic;
signal mem_data_node : std_logic_vector(15 downto 0);
begin
	-- cscs0̂݃ANeBuƂ
	n_mem_cs0 <= '0';
	n_mem_cs1 <= '1';
	n_mem_cs2 <= '1';
	n_mem_cs3 <= '1';
	
	-- mem_addrBr_w vga_mem_addr  cam_mem_addr ؂ւ
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' then
				mem_addr <= (others => '0');
			else
				if r_w = '0' then -- POɃb`
					mem_addr <= vga_mem_addr;
				else
					mem_addr <= cam_mem_addr;
				end if;
			end if;
		end if;
	end process;
	
	-- n_mem_lowerB , n_mem_upperB o͂BXe[g}V͏򂪂Ȃ邮邾B
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				cs_ul <= read_state1;
			else
				cs_ul <= ns_ul;
			end if;
		end if;
	end process;
	
	process(cs_ul, r_w) begin
		case cs_ul is
			when read_state1 => -- Read̏ꍇ16rbgǂݏôUBLBANeBu
				n_mem_upperB <= '0';
				n_mem_lowerB <= '0';
				ns_ul <= upper_state;
			when upper_state =>
				n_mem_upperB <= '0';
				n_mem_lowerB <= '1';
				ns_ul <= read_state2;
			when read_state2 =>
				n_mem_upperB <= '0';
				n_mem_lowerB <= '0';
				ns_ul <= lower_state;
			when lower_state =>
				n_mem_upperB <= '1';
				n_mem_lowerB <= '0';
				ns_ul <= read_state1;
		end case;
	end process;
	
	-- n_mem_we, mem_data_oe 𐶐B48MHz̃Xe[g}Vŏo
	process(clk48) begin
		if clk48'event and clk48='1' then
			if reset='1' then
				cs_we <= idle_we;
			else
				cs_we <= ns_we;
			end if;
		end if;
	end process;
	
	process(cs_we, r_w, cam_href_3d) begin
		case cs_we is
			when idle_we =>
				n_mem_we_node <= '1';
				mem_data_oe <= '0';
				if r_w='0' and cam_href_3d='1' then -- href̊ԂSRAMWrite
					ns_we <= we_active;
				else
					ns_we <= idle_we;
				end if;
			when we_active => -- r_w 148MHzNbN1NbNԂ n_mem_we 0ɂ
				n_mem_we_node <= '0';
				mem_data_oe <= '1';
				ns_we <= we_holdoff;
			when we_holdoff => -- ̎͂܂r_w0
				n_mem_we_node <= '1';
				mem_data_oe <= '0';
				ns_we <= idle_we;
		end case;
	end process;
	n_mem_we <= n_mem_we_node;
	
	-- mem_data o
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' then
				mem_data_out <= (others => '0');
			else
				if cs_ul=read_state1 then -- upper_state
					mem_data_out(15 downto 8) <= cam_ydata_in;
				elsif cs_ul=read_state2 then -- lower_state
					mem_data_out(7 downto 0) <= cam_ydata_in;
				end if;
			end if;
		end if;
	end process;
	
end RTL;			

