-- VGA Display Controller
-- SRAM24MHzA16bit21ǂ݂ꂽPxRGBɕϊĔŕ\
-- SRAM̃AhX͕ʂ̃W[Ő邻̂߂h_countv_counto͂
-- data_enable ͕Kh_count(0)̎1ƂȂ邱ƁB
-- pixel_y_data h_count 1NbNxĂ̂ƂB]h_sync_out v_sync_out 1NbNx
-- pixel_y_data ͏8rbgo͂ĂA8rbgo͂
-- master_syncœB1x΁A^C~OIɂ͂҂Ȃ̂ňȌ͂҂荇͂AÔ߃J1t[IɓBƂ̓obN|[`̎Ȃ̂ŁAׂĂFFZbgĂv
-- V~[V̂߂ɂACMOSJœǂłf[^\邱ƂɂB̂߂ɂmaster_sync@QNbNxꂽƂœB

library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

library work;
use work.disp_timing_pack.all;

entity VGA_Display_Controller is
	port(
		clk : in std_logic;
		reset : in std_logic;
		master_sync : in std_logic; -- \^C~O̓M
		pixel_y_data : in std_logic_vector(15 downto 0); -- Ỹf[^Adata_enable1̎ɗL
		data_enable : in std_logic;
		h_count_out : out unsigned(9 downto 0); -- JE^̃JEgo
		v_count_out : out unsigned(9 downto 0); -- JE^̃JEgo
		red_out : out std_logic_vector(7 downto 0); -- VGAo
		green_out : out std_logic_vector(7 downto 0); -- VGAo
		blue_out : out std_logic_vector(7 downto 0); -- VGAo
		blank_out : out std_logic; -- BLANKo
		h_syncx_out : out std_logic; -- o
		v_syncx_out : out std_logic; -- o
		mem_addr : out std_logic_vector(18 downto 0) -- SRAM̃AhXAoCgP
	);
end VGA_Display_Controller;

architecture RTL of VGA_Display_Controller is

signal h_count : unsigned(9 downto 0); -- JE^
signal v_count : unsigned(9 downto 0); -- JE^
signal red, green, blue : std_logic_vector(7 downto 0);
signal red_next, green_next, blue_next : std_logic_vector(7 downto 0);
signal h_syncx_d1, h_syncx_d2, h_syncx_d3 : std_logic;
signal v_syncx_d1, v_syncx_d2, v_syncx_d3 : std_logic;
signal blank : std_logic;
signal mem_a : unsigned(18 downto 0);
signal master_sync_d1, master_sync_d2, master_sync_d3 : std_logic;

begin
	-- JE^
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				h_count <= (others => '0');
			elsif h_count >= (H_SUM-1) then -- h_count H_SUM-1傫0ɖ߂(mod H_SUM)
				h_count <= (others => '0');
			else
				h_count <= h_count + 1;
			end if;
		end if;
	end process;
	h_count_out <= h_count;
	
	-- JE^
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				v_count <= (others => '0');
			elsif h_count=(H_SUM-1) then -- JE^NAƂ
				if v_count >= (V_SUM-1) then -- v_count V_SUM-1傫0ɖ߂(mode V_SUM)
					v_count <= (others => '0');
				else
					v_count <= v_count + 1;
				end if;
			end if;
		end if;
	end process;
	v_count_out <= v_count;

	-- red, green, blueo
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				red <= (others => '0');
				green <= (others => '0');
				blue <= (others => '0');
			elsif h_count<1 then -- pixel_y_data1NbNx̂ŁA\͈͊O
				red <= (others => '0');
				green <= (others => '0');
				blue <= (others => '0');
			elsif h_count<=H_ACTIVE_VIDEO and v_count<V_ACTIVE_VIDEO then -- \͈́i1NbNxj
				if data_enable='1' then -- f[^enable
					red <= pixel_y_data(15 downto 8); -- ŏ͏8rbg
					green <= pixel_y_data(15 downto 8);
					blue <= pixel_y_data(15 downto 8);
				else -- enable0̎1̎Ƀb`Ă pixel_y_data(7 downto 0)gp
					red <= red_next;
					green <= green_next;
					blue <= blue_next;
				end if;
			else -- \͈͊O
				red <= (others => '0');
				green <= (others => '0');
				blue <= (others => '0');
			end if;
		end if;
	end process;
	red_out <= red;
	green_out <= green;
	blue_out <= blue;
	
	-- red_next, green_next, blue_next̏o
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				red_next <= (others => '0');
				green_next <= (others => '0');
				blue_next <= (others => '0');
			elsif data_enable='1' then
				red_next <= pixel_y_data(7 downto 0);
				green_next <= pixel_y_data(7 downto 0);
				blue_next <= pixel_y_data(7 downto 0);
			end if;
		end if;
	end process;
	
	-- h_syncx̏o(Ƃƃf[^1NbNxāAred, green, blueo͂邽߂1NbNxĂ̂ŁA2NbNxj
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				h_syncx_d1 <= '1';
				h_syncx_d2 <= '1';
				h_syncx_d3 <= '1';
			else
				if h_count>(H_ACTIVE_VIDEO + H_FRONT_PORCH) and h_count<(H_ACTIVE_VIDEO + H_FRONT_PORCH + H_SYNC_PULSE) then -- 
					h_syncx_d1 <= '0';
				else
					h_syncx_d1 <= '1';
				end if;
				
				h_syncx_d2 <= h_syncx_d1;
				h_syncx_d3 <= h_syncx_d2;
			end if;
		end if;
	end process;
	h_syncx_out <= h_syncx_d2;
	
	-- v_syncx̏o(Ƃƃf[^1NbNxāAred, green, blueo͂邽߂1NbNxĂ̂ŁA2NbNxj
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				v_syncx_d1 <= '1';
				v_syncx_d2 <= '1';
				v_syncx_d3 <= '1';
			else
				if v_count>(V_ACTIVE_VIDEO + V_FRONT_PORCH) and v_count<(V_ACTIVE_VIDEO + V_FRONT_PORCH + V_SYNC_PULSE) then -- 
					v_syncx_d1 <= '0';
				else
					v_syncx_d1 <= '1';
				end if;
				
				v_syncx_d2 <= v_syncx_d1;
				v_syncx_d3 <= v_syncx_d2;
			end if;
		end if;
	end process;
	v_syncx_out <= v_syncx_d2;
	
	-- BLANKo, 1NbNxĂ
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				blank <= '1';
			else
				if h_count>=1 and h_count<=H_ACTIVE_VIDEO and v_count<V_ACTIVE_VIDEO then -- \͈́i1NbNxj
					blank <= '0';
				else
					blank <= '1';
				end if;
			end if;
		end if;
	end process;
	blank_out <= blank;
	
	-- SRAM̃AhX̐
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' or master_sync='1' then
				mem_a <= (others => '0');
			else
				if h_count<H_ACTIVE_VIDEO and v_count<V_ACTIVE_VIDEO then -- fBXvC\
					mem_a <= mem_a + 1;
				elsif v_count>V_ACTIVE_VIDEO + V_FRONT_PORCH + V_SYNC_PULSE then -- VSYNCISRAMAhXZbg
					mem_a <= (others => '0');
				end if;
			end if;
		end if;
	end process;
	mem_addr <= std_logic_vector(mem_a);				

end RTL;

	

		