-- synchronizer
-- synchronizergp̂́AFPGAɓ͂ꂽcam_hrefcam_vsyncIOBFFʂ1NbNfBCMB̑̃W[2NbNxMp
-- cam_vsync_1d 10ɂȂ̍ŏ cam_href_1d ̗オœM(master_sync)o͂
-- ɏo͂R_WM1(Read)ɂ

library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

entity synchronizer is
	port(
		clk : in std_logic;
		reset : in std_logic;
		cam_vsync_1d : in std_logic;
		cam_href_1d : in std_logic;
		master_sync : out std_logic;
		r_w : out std_logic
	);
end synchronizer;

architecture RTL of synchronizer is
type sync_state is (idle_sync, vsync_assert, vsync_deassert, sync_active);
signal cs_sync, ns_sync : sync_state;
type rw_state is (idle_rw, read_state, write_state);
signal cs_rw, ns_rw : rw_state;
signal msync : std_logic;
signal r_w_node : std_logic;

begin
	-- master_synco͂Xe[g}V
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' then
				cs_sync <= idle_sync;
			else
				cs_sync <= ns_sync;
			end if;
		end if;
	end process;
	
	process(cs_sync, cam_vsync_1d, cam_href_1d) begin
		msync <= '0';
		case cs_sync is
			when idle_sync =>
				if cam_vsync_1d='1' then
					ns_sync <= vsync_assert;
				else
					ns_sync <= idle_sync;
				end if;
			when vsync_assert =>
				if cam_vsync_1d='0' then
					ns_sync <= vsync_deassert;
				else
					ns_sync <= vsync_assert;
				end if;
			when vsync_deassert =>
				if cam_href_1d='1' then
					ns_sync <= sync_active;
				else
					ns_sync <= vsync_deassert;
				end if;
			when sync_active =>
				msync <= '1';
				ns_sync <= idle_sync;
		end case;
	end process;
	master_sync <= msync;
	
	-- r_wo͂Xe[g}V
	process(clk) begin
		if clk'event and clk='1' then
			if reset='1' then
				cs_rw <= idle_rw;
			else
				cs_rw <= ns_rw;
			end if;
		end if;
	end process;
	
	-- ̑̃W[̓1NbNx̂ŁAŏwrite_stateƂȂ
	process(cs_rw, cs_sync, cam_href_1d) begin
		case cs_rw is
			when idle_rw =>
				r_w_node <= '1';
				if cs_sync=vsync_deassert and cam_href_1d='1' then
					ns_rw <= write_state;
				else
					ns_rw <= idle_rw;
				end if;
			when read_state =>
				r_w_node <= '1';
				if cs_sync=vsync_deassert and cam_href_1d='1' then
					ns_rw <= write_state;
				else
					ns_rw <= write_state;
				end if;
			when write_state =>
				r_w_node <= '0';
				if cs_sync=vsync_deassert and cam_href_1d='1' then
					ns_rw <= write_state;
				else
					ns_rw <= read_state;
				end if;
		end case;
	end process;
	r_w <= r_w_node;
end RTL;


					
	